/*
===============================================================================

  FILE:  SVreader_mesh3d.h
  
  CONTENTS:
  
    Reads a mesh from the Mesh3D format and presents it as a (poor) streaming mesh.
  
  PROGRAMMERS:
  
    martin isenburg@cs.unc.edu
  
  COPYRIGHT:
  
    copyright (C) 2008  martin isenburg@cs.unc.edu
    
    This software is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  
  CHANGE HISTORY:
  
    08 August 2008 -- created after realizing I really need to forget Henna now
  
===============================================================================
*/
#ifndef SVREADER_MESH3D_H
#define SVREADER_MESH3D_H

#include "svreader.h"

#include <stdio.h>

class SVreader_mesh3d : public SVreader
{
public:

  // SVreader interface function implementations

  SVevent read_element();
  SVevent read_event();

  void close(bool close_file=true);

  // SVreader_mesh3d functions

  bool open(FILE* file);

  SVreader_mesh3d();
  ~SVreader_mesh3d();

private:
  FILE* file;
  int skipped_lines;
  char* line;
};

#endif
