/*
===============================================================================

  FILE:  svreadopener.h
  
  CONTENTS:
  
    Takes a file_name and/or a format description as input and opens streaming
    (and non-streaming) meshes in various formats for read access. This avoids to
    (a) having to reimplement opening different formats in new applications
    (b) having to add new formats to every existing application

  PROGRAMMERS:
  
    martin isenburg@cs.unc.edu
  
  COPYRIGHT:
  
    copyright (C) 2007  martin isenburg@cs.unc.edu
    
    This software is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  
  CHANGE HISTORY:

    01 October 2007 -- created the day that I got my first paycheck from LLNL

===============================================================================
*/
#ifndef SVREADOPENER_H
#define SVREADOPENER_H

#include "svreader.h"

#include <stdio.h>

class SVreadOpener
{
public:

  void set_file_name(const char* file_name);
  void set_file_format(const char* file_format);

  SVreader* open();
  bool reopen(SVreader* svreader);

  SVreadOpener();
  ~SVreadOpener();

  char* file_name;
  char* file_format;
};

#endif
